/*
  File name: File3Dg.h
  Copyright: (C) 2007 - 2008 Tomasz Kazmierczak

  Creation date: 20.04.2007
  Last modification date: 20.06.2008

  This file is part of Cytadela

 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 3 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *

*/

#ifndef _FILE3DG_H_
#define _FILE3DG_H_

#include <stdio.h>
#include "I3Dg.h"

class FileHeader3Dg {
public:
	uint32_t  dwId;                 //file identifier
	uint32_t  dwVersion;             //file version
	uint32_t  dwReserved1;
	uint32_t  dwReserved2;
};

class File3Dg : public I3Dg {
private:
	bool read(FILE *p3DgFile);
	bool write(FILE *p3DgFile);
	bool readLight(FILE *p3DgFile);
	bool readTexture(FILE *p3DgFile);
	bool readMaterial(FILE *p3DgFile);
	bool readMeshBase(FILE *p3DgFile);
	bool readMesh(FILE *p3DgFile);

public:
	bool read(const char *sz3DgFileName);
	bool write(const char *sz3DgFileName);
};

#endif //_FILE3DG_H_
